// DS's posting and editing functions for LiveJournal.
if (!window.arguments) {
	LiveJournal = parent.LiveJournal;
	dsAccounts = parent.dsAccounts;
	var isSidebar = parent.isSidebar;
}

dsPosts = new Object();
var dsPrefs = new PrefsWrapper1("extensions.deepestSender.");

function Init() {
	// Main init function obviously.
	// In: Nothing.
	// Out: Nothing.
	document.getElementById("ljbuttons").collapsed = false;
	if (isSidebar) {
		document.getElementById("mainbox").orient = "vertical";
		document.getElementById("postoptions").collapsed = true;
	}
	if (dsPrefs.getIntPref("DetectMethod") == 0) {
		document.getElementById("detectmusic").collapsed = true;
	}
	var picalign = ["start", "center", "end"]
	document.getElementById("userpicbox").setAttribute("pack", picalign[dsPrefs.getIntPref("PicAlign")]);
	
	var tbbg = document.defaultView.getComputedStyle(document.getElementById("messagesource"), "").getPropertyValue("background-color");
	var tbfg = document.defaultView.getComputedStyle(document.getElementById("messagesource"), "").getPropertyValue("color");
	var mbox = document.getElementById("message").contentWindow;
	mbox.document.body.style.backgroundColor = tbbg;
	mbox.document.body.style.color = tbfg
	
	
	ljPost.usejournal = LiveJournal.username;
	
	var pickwlist = document.getElementById("picture");
	pickwlist.appendChild(document.createElement("menupopup"));
	pickwlist.appendItem("[default]", LiveJournal.defaultpicurl);
	for (i = 0; i < LiveJournal.pickws.length; i++) {
		pickwlist.appendItem(LiveJournal.pickws[i].pickw, LiveJournal.pickws[i].url);
	}
	pickwlist.selectedIndex = 0;

	var moodlist = document.getElementById("moods");
	moodlist.appendChild(document.createElement("menupopup"));
	for (i = 0; i < LiveJournal.moods.length; i++) {
		moodlist.appendItem(LiveJournal.moods[i].mood, LiveJournal.moods[i].id);
	}


	document.getElementById("usernametitle").value = LiveJournal.username;
	
	dsPosts.resetPostParameters();
	if (!window.arguments) {
		InitPosting();
	} else {
		InitEditing();
	}
}

function InitPosting() {
	var journallist = document.getElementById("usejournal");
	journallist.appendChild(document.createElement("menupopup"));
	journallist.appendItem(LiveJournal.username);
	for (i = 0; i < LiveJournal.usejournals.length; i++) {
		journallist.appendItem(LiveJournal.usejournals[i]);
	}
	journallist.selectedIndex = 0;
}

dsPosts.changeJournal = function(obj) {
	// Sets the ljPost object's usejournal to the currently selected journal.
	// In: The usejournal menu node.
	// Out: Nothing.
	ljPost.usejournal = obj.label;
}

dsPosts.changePicture = function(obj) {
	// Changes the selected pic keyword (and the picture shown in the userpic box).
	// In: The picture menu object.
	// Out: Nothing.
	ljPost.pickw = obj.label;
	document.getElementById("userpic").src = obj.value;	
}

dsPosts.changeSecurity = function(selindex, skipdialog) {
	// Sets the current security, and opens a dialog to choose the filters if skipdialog is false and 'custom'
	//	is selected.
	// In: A number. Taken from the security node. 0 = public, 1 = private, 2 = friends, 3 = custom.
	// Out: Nothing.
	switch (selindex) {
		case 2:
			ljPost.security = selindex;
			ljPost.allowmask = 1;
			break;
		case 3:
			ljPost.security = 2;
			if (!skipdialog) {
				window.openDialog("security.xul","security","chrome,modal",ljPost,LiveJournal);
				if (ljPost.allowmask < 2) {
					document.getElementById("security").selectedIndex = 1;
					ljPost.security = 1;
				}
			}
			break;
		default:
			ljPost.security = selindex;
			break;
	}
}

dsPosts.visitJournal = function() {
	// Opens the currently selected journal in the most recent browser window.
	// In: Nothing.
	// Out: Nothing.
	var domain = FindDomain(LiveJournal.posturl);
	var ljpage = domain + "users/" + ljPost.usejournal;
	openTopWin(ljpage);
}

dsPosts.resetPostParameters = function() {
	// Resets all the post values to their defaults, and clears out the subject/message boxes. Use when loading, and
	//	upon completion of a successful post.
	// In: Nothing.
	// Out: Nothing.
	dsMidas.setUpMidas();
	document.getElementById("subject").value = null;
	document.getElementById("security").selectedIndex = parseInt(LiveJournal.defaultsecurity, 10);
	this.changeSecurity(document.getElementById("security").selectedIndex);
	ljPost.allowmask = LiveJournal.defaultgroups;
	ljPost.backdate = LiveJournal.defaultbackdate;
	ljPost.removecomments = LiveJournal.defaultremovecomments;
	ljPost.dontautoformat = LiveJournal.defaultdontautoformat;
	dsMidas.dontautoformat = LiveJournal.defaultdontautoformat
	document.getElementById("picture").selectedIndex = 0;
	document.getElementById("userpic").src = LiveJournal.defaultpicurl;
	document.getElementById("moods").label = null;
	document.getElementById("music").value = null;
	
}

dsPosts.sendPost = function() {
	// Disables everything (well, not everything - menus still work and userpic is still clickable) and starts posting.
	//	Oh, and if this function is called again before the other has completed, it cancels everything.
	// In: Nothing.
	// Out: Nothing.
	if (this.posting) {
		this.posting = false;
		document.getElementById("maindisabler").removeAttribute("disabled");
		document.getElementById("messagedeck").selectedIndex = 0;
		document.getElementById("postbutton").label = "Post";
	} else {
		if (dsPrefs.getBoolPref("SpellCheckOnPost")) {
			// goDoCommand won't work for some reason.
			eval(document.getElementById("cmd_spell").getAttribute("oncommand"));
		}
		if (dsPrefs.getBoolPref("AutoDetectMusic")) {
			var detectedmusic = FindMusic();
			if (detectedmusic.length > 0) {
				document.getElementById("music").value = detectedmusic;
			}
		}
		document.getElementById("postbutton").label = "Cancel";
		document.getElementById("maindisabler").setAttribute("disabled", true);
		document.getElementById("statuslabel").value = "Posting...";
		document.getElementById("progressbar").mode = "undetermined";
		document.getElementById("messagedeck").selectedIndex = 1;
		this.posting = true;
		ljPost.startPost();
	}
}

function ljUser() {
	var usertag = [];
	window.openDialog("insertljuser.xul","insertljuser","chrome,modal",usertag);
	if (usertag[0] != null) {
		var ljuser = "<span class=\"" + usertag[1].value + "\">" + usertag[0] + "</span>&nbsp;";
		document.getElementById("message").contentDocument.execCommand("insertHTML", false, ljuser);
	}
}

function ljCut() {
	var cut = prompt("Enter some text to go in the cut, or leave blank", "");
	if (typeof(cut) == "string") {
		var win = document.getElementById("message");
		var ljstart, ljend;
		ljend = "</lj-cut>";
		if (cut.length > 0) {
			ljstart = "<lj-cut text=\"" + cut + "\">";
		} else {
			ljstart = "<lj-cut>";
		}
		var selection = win.contentWindow.getSelection();
		var rangeCount = selection.rangeCount;
		if(rangeCount >= 0) {
			var rangeAt = selection.getRangeAt(0);
			var rangeTwo = document.createRange();
			rangeTwo.setStart(rangeAt.endContainer,rangeAt.endOffset);
			rangeTwo.insertNode(document.createTextNode(ljend));
			rangeAt.insertNode(document.createTextNode(ljstart));
		}
	}
}

function OpenHistoryWindow() {
	var windowmanager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var history = windowmanager.getMostRecentWindow("deepestsender:history"); 
	if (history) {
		history.focus();
	} else {
		window.openDialog("history.xul","dshistory","chrome,dependent", LiveJournal, ljPost);
	}
}

function EditLastEntry() {
	var windowwatcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
	var editwindow = windowwatcher.getWindowByName("dslastentry", null);
	if (editwindow) {
		editwindow.focus();
	} else {
		window.openDialog("livejournal.xul","dslastentry","chrome,resizable,titlebar,dialog=no", LiveJournal, -1, ljPost.usejournal);
	}
}

function OpenPostOptions() {
	if (typeof(dsAccounts) != "undefined") {
		window.openDialog('postoptions.xul','dspostoptions','chrome,modal',LiveJournal,dsPosts,window,dsPrefs,ljPost,dsAccounts);
	} else {
		window.openDialog("postoptions.xul","dspostoptions","chrome,modal",LiveJournal,dsPosts,window,dsPrefs,ljPost);
	}
}
