/*
  Desc: Installation script
  Modified version of Chris Pederick's install script from WD.
  Author: Jed Brown (jedbro@gmx.net)
*/
const author              = "David Murray";
const displayName         = "Deepest Sender";
const name                = "deepestsender";
const version             = "0.6.0";
var error                 = null;
var folder                = getFolder("Profile", "chrome");
var contentFlag           = CONTENT | PROFILE_CHROME;
var localeFlag            = LOCALE | PROFILE_CHROME;
var skinFlag              = SKIN | PROFILE_CHROME;
var jarName               = name + ".jar";
var existsInApplication   = File.exists(getFolder(getFolder("chrome"), jarName));
var existsInProfile       = File.exists(getFolder(folder, jarName));
const SUCCESS_MESSAGE     = " is now installed. You can access it from the Window\n \
menu, or via the status bar down the bottom of the screen. To install to the sidebar,\n \
check the Deepest Sender options, which are with the rest of the Mozilla Preferences.";

initInstall(displayName, name, version);

// If the extension exists in the application folder or it doesn't exist in the 
// profile folder and the user doesn't want it installed to the profile folder
if(existsInApplication || (!existsInProfile && !confirm("Do you want to \
install the extension into your profile folder?\n(Cancel will install into the \
application folder). Note that you need write permissions to the application folder, \
\nregardless of where you choose to install to.")))

{
  folder      = getFolder("chrome");
  contentFlag = CONTENT | DELAYED_CHROME;
  localeFlag  = LOCALE | DELAYED_CHROME;
  skinFlag    = SKIN | DELAYED_CHROME;
}

//setPackageFolder(folder);
error = addFile(author, version, 'chrome/' + jarName, folder, "");
if (error == SUCCESS) {
  // install icons
  var iconfolder = getFolder(getFolder("chrome", "icons"), "default");
  addFile(name, "icons/deepestdender.ico", iconfolder, "");
  addFile(name, "icons/deepestsender.xpm", iconfolder, "");

  // install default prefs
  var prefsfolder = getFolder(getFolder("Program", "defaults"), "pref");
  addFile(name, "defaults/preferences/deepestsender.js", prefsfolder, "");
  
  // install components
  var componentsfolder = getFolder("Components");
  addFile(name, version, "components/nsXmlRpcClient2.js", componentsfolder, "nsXmlRpcClient2.js", true);
}

// If adding the JAR file succeeded
if(error == SUCCESS)
{
  folder = getFolder(folder, jarName);
  registerChrome(contentFlag, folder, "content/");
  registerChrome(localeFlag, folder, "locale/en-US/");
  registerChrome(skinFlag, folder, "skin/classic/");
 
  error = performInstall();
  
  if(error == SUCCESS || error == 999)
  {
    alert(displayName+" "+version+" has been succesfully installed.\n"+displayName + SUCCESS_MESSAGE);
  } else { // If the install failed
    alert("Install failed. Error code:" + error);
    cancelInstall(error);
  }
}
else
{
  alert("The installation of the extension failed.\n" + error + "\n Failed to create " +jarName+ " \n"
        +"Make sure you have the correct permissions.");
  cancelInstall(error);
}

