ljDates = new Object();
ljDelete = new Object();
LiveJournal = window.arguments[0];
ljPost = window.arguments[1];

function Init() {
	// Initial function, sets up calendar.
	// In: Nothing.
	// Out: Nothing.
	document.getElementById("progressbar").mode = "undetermined";	
	dsCalendar.extraSetSelected = function(day, month, year) {
		var eventlist = document.getElementById("entrieslist");
		while (eventlist.childNodes.length > 2) {
			eventlist.removeChild(eventlist.lastChild);
		}
		eventlist.appendChild(document.createElement("listitem"));
		eventlist.lastChild.setAttribute("label", "Loading...");
		document.getElementById("progressdeck").selectedIndex = 0;
		ljEvents.getEventsChallenge();
	}
	
	dsCalendar.extraChangeYear = function(curobj) {
		curobj.setAttribute("oncommand", curobj.getAttribute("oncommand") + " MakeBoldDays(dsCalendar.year, parseInt(dsCalendar.month + 1, 10), ljDates.dates);");
	}
	
	var cal = new Date();
	dsCalendar.init(cal);
	dsCalendar.setSelected(document.getElementById("day" + dsCalendar.selectedday));
	var mpop = document.getElementById("monthspopup");
	for (i = 0; i < mpop.childNodes.length; i++) {
		mpop.childNodes[i].setAttribute("oncommand", mpop.childNodes[i].getAttribute("oncommand") + " MakeBoldDays(dsCalendar.year, parseInt(dsCalendar.month + 1, 10), ljDates.dates);");
	}
	var monthless = document.getElementById("monthless");
	var monthmore = document.getElementById("monthmore");
	monthless.setAttribute("oncommand", monthless.getAttribute("oncommand") + " MakeBoldDays(dsCalendar.year, parseInt(dsCalendar.month + 1, 10), ljDates.dates);");
	monthmore.setAttribute("oncommand", monthmore.getAttribute("oncommand") + " MakeBoldDays(dsCalendar.year, parseInt(dsCalendar.month + 1, 10), ljDates.dates);");
	ljDates.getDatesChallenge();
}

ljDates.getDatesChallenge = function() {
	this.xmlrpc = Components.classes["@mozilla.org/xml-rpc/client2;1"].createInstance(Components.interfaces.nsIXmlRpcClient);
	this.xmlrpc.init(LiveJournal.posturl);
	this.xmlrpc.asyncCall(this.challengeHandler, null, "LJ.XMLRPC.getchallenge", [], 0);
}

ljDates.challengeHandler = {
	// This gets hit as the response from the server when asked for a challenge. The code should be pretty self-explanatory.
	onResult: function(client, ctxt, result) {
			var results = result.QueryInterface(Components.interfaces.nsIDictionary);
			var challenge = results.getValue("challenge").QueryInterface(Components.interfaces.nsISupportsCString);
			ljDates.getDates(challenge);
	},
	onFault: function (client, ctxt, fault) {
			alert('XML-RPC Fault: '+fault);
	},
	onError: function (client, ctxt, status, errorMsg) {
			alert('Error: '+errorMsg);
	}
}

ljDates.getDates = function(challengestring) {
	this.xmlrpc.init(LiveJournal.posturl);
	var dictionary = this.xmlrpc.createType(this.xmlrpc.STRUCT, {});
	var paramstrings = new Object();
	var paramints = new Object();
	paramstrings.username = LiveJournal.username;
	paramstrings.auth_method = "challenge";
	paramstrings.auth_challenge = challengestring;
	paramstrings.auth_response = hexMD5(challengestring + hexMD5(LiveJournal.password));
	paramints.ver = 1;
	if (LiveJournal.username != ljPost.usejournal) {
		paramstrings.usejournal = ljPost.usejournal;
	}
	this.makeRPCObjs(paramstrings, this.xmlrpc.STRING, dictionary);
	this.makeRPCObjs(paramints, this.xmlrpc.INT, dictionary);
	this.xmlrpc.asyncCall(this.datesHandler, null, "LJ.XMLRPC.getdaycounts", [dictionary], 1);
}

ljDates.datesHandler = {
	// This gets hit as the response from the server when asked for a challenge. The code should be pretty self-explanatory.
	onResult: function(client, ctxt, result) {
			var results = result.QueryInterface(Components.interfaces.nsIDictionary);
			var dates = results.getValue("daycounts").QueryInterface(Components.interfaces.nsISupportsArray);
			ljDates.dates = [];
			for (i = 0; i < dates.Count(); i++) {
				ljDates.dates[i] = [];
				var date = dates.QueryElementAt(i, Components.interfaces.nsIDictionary);
				ljDates.dates[i].date = date.getValue("date").QueryInterface(Components.interfaces.nsISupportsCString);
				ljDates.dates[i].postcount = date.getValue("count").QueryInterface(Components.interfaces.nsISupportsPRInt32);
				
			}
			var now = new Date();
			MakeBoldDays(now.getFullYear(), now.getMonth() + 1, ljDates.dates);
	},
	onFault: function (client, ctxt, fault) {
			alert('XML-RPC Fault: '+fault);
	},
	onError: function (client, ctxt, status, errorMsg) {
			alert('Error: '+errorMsg);
	}
}

ljDates.makeRPCObjs = function(paramobj, makeobj, dict) {
	// Hmm. Identical to the makeRPCObjs function in livejournal.js. Note to self: Combine the two.
	// In: An object. Each item must be of an identical type (specified in the second parameter).
	//	They'll all be added to the dictionary specified in  the 'dict' parameter.
	// Out: Nothing, but your dict object will be populated.
	for (i in paramobj) {
		var rpcobj = this.xmlrpc.createType(makeobj, {});
		rpcobj.data = paramobj[i];
		dict.setValue(i, rpcobj);
	}
}

function MakeBoldDays(year, month, datesxml) {
	var days = document.getElementById("calendarbox").getElementsByTagName("toolbarbutton");
	for (i = 0; i < days.length; i++) {
		var dateid = days[i].getAttribute("id");
		var curday = dateid.match(/[^day]/gi).join("");
		var datestring = year + "-" + ZeroFix(month) + "-" + ZeroFix(curday);
		for (j = ljDates.dates.length -1; j >= 0; j--) {
			if (ljDates.dates[j].date == datestring) {
			days[i].setAttribute("style", "font-weight: bold");
			days[i].setAttribute("tooltiptext", ljDates.dates[j].postcount + " posts on this day");
			break;
			}
		}
	}
	window.sizeToContent();
}

function ZeroFix(TheNumber) {
	// To pad out numbers so they're always 2 digits long.
	if (TheNumber < 10) { TheNumber = "0" + TheNumber; }
	return TheNumber;
}

function FixClock(time) {
	var clockarray = time.split(":");
	var hour = clockarray[0];
	var minute = clockarray[1];
	var ampm = " am";
	hour = parseInt(hour.slice(hour.lastIndexOf(" ")),10);
	if (hour > 11) {
		ampm = " pm";
		hour = hour - 12;
	}
	if (hour == 0) {
		hour = 12;
	}
	return hour + ":" + minute + ampm;
}

function ViewPost(postnode) {
	if (postnode) {
		var domain = FindDomain(LiveJournal.posturl);
		var postsplit = postnode.value.split("|");
		var itemid = postsplit[0];
		var anum = postsplit[1];
		var username;
		if (LiveJournal.username != ljPost.usejournal) {
			username = ljPost.usejournal;
		} else {
			username = LiveJournal.username;
		}
		var urlstring = domain + "users/" + username + "/" + ((parseInt(itemid, 10) * 256) + parseInt(anum, 10)) + ".html";
		openTopWin(urlstring);
	}
}


function EditPost(postnode) {
	if (postnode) {
		var itemid = parseInt(postnode.value.split("|")[0], 10);
		var windowid = "dsedit" + itemid;
		var windowwatcher = Components.classes["@mozilla.org/embedcomp/window-watcher;1"].getService(Components.interfaces.nsIWindowWatcher);
		var editwindow = windowwatcher.getWindowByName(windowid, null);
		if (editwindow) {
			editwindow.focus();
		} else {
			window.openDialog("livejournal.xul",windowid,"chrome,resizable,titlebar,dialog=no", LiveJournal, itemid, ljPost.usejournal);
		}
	}
}

function DeletePost(postnode) {
	if (postnode) {
		if (confirm("Are you sure you want to delete this post?")) {
			document.getElementById("progressdeck").selectedIndex = 0;
			ljDelete.itemid = postnode.value.split("|")[0];
			ljDelete.getChallenge();
		}
	}
}

ljDelete.getChallenge = function() {
	this.xmlrpc = Components.classes["@mozilla.org/xml-rpc/client2;1"].createInstance(Components.interfaces.nsIXmlRpcClient);
	this.xmlrpc.init(LiveJournal.posturl);
	this.xmlrpc.asyncCall(this.challengeHandler, null, "LJ.XMLRPC.getchallenge", [], 0);
}

ljDelete.challengeHandler = {
	// This gets hit as the response from the server when asked for a challenge. The code should be pretty self-explanatory.
	onResult: function(client, ctxt, result) {
			var results = result.QueryInterface(Components.interfaces.nsIDictionary);
			var challenge = results.getValue("challenge").QueryInterface(Components.interfaces.nsISupportsCString);
			ljDelete.deletePost(challenge);
	},
	onFault: function (client, ctxt, fault) {
			alert('XML-RPC Fault: '+fault);
	},
	onError: function (client, ctxt, status, errorMsg) {
			alert('Error: '+errorMsg);
	}
}

ljDelete.deletePost = function(challengestring) {
	this.xmlrpc.init(LiveJournal.posturl);
	var dictionary = this.xmlrpc.createType(this.xmlrpc.STRUCT, {});
	var paramstrings = new Object();
	var paramints = new Object();
	paramstrings.username = LiveJournal.username;
	paramstrings.auth_method = "challenge";
	paramstrings.auth_challenge = challengestring;
	paramstrings.auth_response = hexMD5(challengestring + hexMD5(LiveJournal.password));
	paramints.ver = 1;
	if (LiveJournal.username != ljPost.usejournal) {
		paramstrings.usejournal = ljPost.usejournal;
	}
	paramstrings.subject = "";
	paramstrings.lineendings = "unix";
	paramstrings.event = "";
	paramints.year = 1;
	paramints.month = 1;
	paramints.day = 1;
	paramints.hour = 1;
	paramints.minute = 1;
	paramints.itemid = parseInt(this.itemid, 10);
	this.makeRPCObjs(paramstrings, this.xmlrpc.STRING, dictionary);
	this.makeRPCObjs(paramints, this.xmlrpc.INT, dictionary);
	this.xmlrpc.asyncCall(this.deletionHandler, null, "LJ.XMLRPC.editevent", [dictionary], 1);
}

ljDelete.deletionHandler = {
	// This gets hit as the response from the server when asked for a challenge. The code should be pretty self-explanatory.
	onResult: function(client, ctxt, result) {
			document.getElementById("progressdeck").selectedIndex = 1;
			dsCalendar.setSelected();
	},
	onFault: function (client, ctxt, fault) {
			alert('XML-RPC Fault: '+fault);
	},
	onError: function (client, ctxt, status, errorMsg) {
			alert('Error: '+errorMsg);
	}
}

ljDelete.makeRPCObjs = function(paramobj, makeobj, dict) {
	// Hmm. Identical to the makeRPCObjs function in livejournal.js. Note to self: Combine the two.
	// In: An object. Each item must be of an identical type (specified in the second parameter).
	//	They'll all be added to the dictionary specified in  the 'dict' parameter.
	// Out: Nothing, but your dict object will be populated.
	for (i in paramobj) {
		var rpcobj = this.xmlrpc.createType(makeobj, {});
		rpcobj.data = paramobj[i];
		dict.setValue(i, rpcobj);
	}
}
