ljEvents = new Object();

ljEvents.getEventsChallenge = function() {
	this.xmlrpc = Components.classes["@mozilla.org/xml-rpc/client2;1"].createInstance(Components.interfaces.nsIXmlRpcClient);
	this.xmlrpc.init(LiveJournal.posturl);
	this.xmlrpc.asyncCall(this.challengeHandler, null, "LJ.XMLRPC.getchallenge", [], 0);
}

ljEvents.challengeHandler = {
	onResult: function(client, ctxt, result) {
			var results = result.QueryInterface(Components.interfaces.nsIDictionary);
			var challenge = results.getValue("challenge").QueryInterface(Components.interfaces.nsISupportsCString);
			ljEvents.getEvents(challenge);
	},
	onFault: function (client, ctxt, fault) {
			alert('XML-RPC Fault: '+fault);
	},
	onError: function (client, ctxt, status, errorMsg) {
			alert('Error: '+errorMsg);
	}
}

ljEvents.getEvents = function(challengestring) {
	this.xmlrpc.init(LiveJournal.posturl);
	var dictionary = this.xmlrpc.createType(this.xmlrpc.STRUCT, {});
	var paramstrings = new Object();
	var paramints = new Object();
	var parambools = new Object();
	paramstrings.username = LiveJournal.username;
	paramstrings.auth_method = "challenge";
	paramstrings.auth_challenge = challengestring;
	paramstrings.auth_response = hexMD5(challengestring + hexMD5(LiveJournal.password));
	paramints.ver = 1;
	if (LiveJournal.username != ljPost.usejournal) {
		paramstrings.usejournal = ljPost.usejournal;
	}
	paramints.truncate = 40;
	parambools.prefersubject = true;
	parambools.noprops = true;
	paramstrings.selecttype = "day";
	paramints.year = dsCalendar.year;
	paramints.month = dsCalendar.month + 1;
	paramints.day = dsCalendar.selectedday;
	paramstrings.lineendings = "space";
	this.makeRPCObjs(paramstrings, this.xmlrpc.STRING, dictionary);
	this.makeRPCObjs(paramints, this.xmlrpc.INT, dictionary);
	this.makeRPCObjs(parambools, this.xmlrpc.BOOLEAN, dictionary);
	this.xmlrpc.asyncCall(this.eventsHandler, null, "LJ.XMLRPC.getevents", [dictionary], 1);
}

ljEvents.eventsHandler = {
	// This gets hit as the response from the server when asked for a challenge. The code should be pretty self-explanatory.
	onResult: function(client, ctxt, result) {
			var results = result.QueryInterface(Components.interfaces.nsIDictionary);
			var events = results.getValue("events").QueryInterface(Components.interfaces.nsISupportsArray);
			var eventlist = document.getElementById("entrieslist");
			while (eventlist.childNodes.length > 2) {
				eventlist.removeChild(eventlist.lastChild);
			}
			for (i = 0; i < events.Count(); i++) {
				var event = events.QueryElementAt(i, Components.interfaces.nsIDictionary);
				var eventtime = event.getValue("eventtime").QueryInterface(Components.interfaces.nsISupportsCString);
				var eventblurb = event.getValue("event").QueryInterface(Components.interfaces.nsISupportsCString);
				var eventid = event.getValue("itemid").QueryInterface(Components.interfaces.nsISupportsPRInt32);
				eventid += "|";
				eventid += event.getValue("anum").QueryInterface(Components.interfaces.nsISupportsPRInt32);
				eventlist.appendChild(document.createElement("listitem"));
				eventlist.lastChild.setAttribute("value", eventid);
				eventlist.lastChild.setAttribute("ondblclick", "EditPost(this);");
				eventlist.lastChild.setAttribute("label", FixClock(eventtime.data));
				eventlist.lastChild.appendChild(document.createElement("listcell"));
				eventlist.lastChild.lastChild.setAttribute("label", eventblurb);
			}
			document.getElementById("progressdeck").selectedIndex = 1;
	},
	onFault: function (client, ctxt, fault) {
			alert('XML-RPC Fault: '+fault);
	},
	onError: function (client, ctxt, status, errorMsg) {
			alert('Error: '+errorMsg);
	}
}

ljEvents.makeRPCObjs = function(paramobj, makeobj, dict) {
	// Hmm. Identical to the makeRPCObjs function in livejournal.js. Note to self: Combine the two.
	// In: An object. Each item must be of an identical type (specified in the second parameter).
	//	They'll all be added to the dictionary specified in  the 'dict' parameter.
	// Out: Nothing, but your dict object will be populated.
	for (i in paramobj) {
		var rpcobj = this.xmlrpc.createType(makeobj, {});
		rpcobj.data = paramobj[i];
		dict.setValue(i, rpcobj);
	}
}
