ljEdit = new Object();

if (window.arguments) {
	LiveJournal = window.arguments[0];
	var postnum = window.arguments[1];
}

function InitEditing() {
	ljPost.usejournal = window.arguments[2];
	document.getElementById("usejournal").collapsed = true;
	document.getElementById("postbutton").setAttribute("label", "Save");
	document.getElementById("postbutton").setAttribute("oncommand", "ljEdit.saveEdit()");
	document.getElementById("postbutton").setAttribute("disabled", "true");
	document.getElementById("maindisabler").setAttribute("disabled", true);
	if (postnum == -1) {
		document.getElementById("cmd_lastentry").setAttribute("disabled", true);
	}
	
	document.getElementById("progressbar").mode = "undetermined";
	document.getElementById("statuslabel").value = "Loading...";
	document.getElementById("statuswhat").value = "Loading the selected entry...";
	document.getElementById("messagedeck").selectedIndex = 1;
	window.title = "Deepest Sender: Editing post in " + ljPost.usejournal;
	ljEdit.requestLoadChallenge();
}

ljEdit.requestLoadChallenge = function() {
	this.xmlrpc = Components.classes["@mozilla.org/xml-rpc/client2;1"].createInstance(Components.interfaces.nsIXmlRpcClient);
	this.xmlrpc.init(LiveJournal.posturl);
	document.getElementById("statuswhat").value = "Requesting challenge...";
	this.xmlrpc.asyncCall(this.challengeLoadHandler, null, "LJ.XMLRPC.getchallenge", [], 0);
}

ljEdit.challengeLoadHandler = {
	// In: Nothing.
	// Out: Nothing.
	onResult: function(client, ctxt, result) {
			var results = result.QueryInterface(Components.interfaces.nsIDictionary);
			var challenge = results.getValue("challenge").QueryInterface(Components.interfaces.nsISupportsCString);
			ljEdit.loadMessage(challenge);
	},
	onFault: function (client, ctxt, fault) {
			alert('XML-RPC Fault: '+fault);
	},
	onError: function (client, ctxt, status, errorMsg) {
			alert('Error: '+errorMsg);
	}
}

ljEdit.loadMessage = function(challengestring) {
	this.xmlrpc.init(LiveJournal.posturl);
	var dictionary = this.xmlrpc.createType(this.xmlrpc.STRUCT, {});
	var paramstrings = new Object();
	var paramints = new Object();
	var parambools = new Object();
	paramstrings.username = LiveJournal.username;
	paramstrings.auth_method = "challenge";
	paramstrings.auth_challenge = challengestring;
	paramstrings.auth_response = hexMD5(challengestring + hexMD5(LiveJournal.password));
	paramints.ver = 1;
	if (LiveJournal.username != ljPost.usejournal) {
		paramstrings.usejournal = ljPost.usejournal;
	}
	paramstrings.selecttype = "one";
	paramints.itemid = postnum;
	paramstrings.lineendings = "unix";
	this.makeRPCObjs(paramstrings, this.xmlrpc.STRING, dictionary);
	this.makeRPCObjs(paramints, this.xmlrpc.INT, dictionary);
	this.xmlrpc.asyncCall(this.loadHandler, null, "LJ.XMLRPC.getevents", [dictionary], 1);
}

ljEdit.loadHandler = {
	// In: Nothing.
	// Out: Nothing.
	onResult: function(client, ctxt, result) {
			var results = result.QueryInterface(Components.interfaces.nsIDictionary);
			var events = results.getValue("events").QueryInterface(Components.interfaces.nsISupportsArray);
			// Only 1 event is returned for this, but it's still in an array.
			// I just *know* this'll be the most frustrating part out of this entire program.
			var eventdict = events.QueryElementAt(0, Components.interfaces.nsIDictionary);
			
			var eventtime = eventdict.getValue("eventtime").QueryInterface(Components.interfaces.nsISupportsCString);
			postnum = eventdict.getValue("itemid").QueryInterface(Components.interfaces.nsISupportsPRInt32);

			// Insert complete ridiculousness here.
			try {
				var security = eventdict.getValue("security").QueryInterface(Components.interfaces.nsISupportsCString);
			} catch(e) {
			}
			try {
				var subject = eventdict.getValue("subject").QueryInterface(Components.interfaces.nsISupportsCString);
			} catch(e) {
			}
			var event = eventdict.getValue("event").QueryInterface(Components.interfaces.nsISupportsCString);
			try {
				var props = eventdict.getValue("props").QueryInterface(Components.interfaces.nsIDictionary);
				try {
					var mood = props.getValue("current_mood").QueryInterface(Components.interfaces.nsISupportsCString);
				} catch(e) {
				}
				try {
					var moodid = props.getValue("current_moodid").QueryInterface(Components.interfaces.nsISupportsPRInt32);
				} catch(e) {
				}
				try {
					var music = props.getValue("current_music").QueryInterface(Components.interfaces.nsISupportsCString);
				} catch(e) {
				}
				try {
					var dontautoformat = props.getValue("opt_preformatted").QueryInterface(Components.interfaces.nsISupportsPRInt32);
				} catch(e) {
				}
				try {
					var removecomments = props.getValue("opt_nocomments").QueryInterface(Components.interfaces.nsISupportsPRInt32);
				} catch(e) {
				}
				try {
					var pickw = props.getValue("picture_keyword").QueryInterface(Components.interfaces.nsISupportsCString);
				} catch(e) {
				}
				try {
					var backdate = props.getValue("opt_backdated").QueryInterface(Components.interfaces.nsISupportsPRInt32);
				} catch(e) {
				}
			} catch(e) {
			}
			var etarray = eventtime.data.split(" ");
			var datearray = etarray[0].split("-");
			var timearray = etarray[1].split(":");
			ljPost.year = parseInt(datearray[0], 10);
			ljPost.month = parseInt(datearray[1], 10);
			ljPost.day = parseInt(datearray[2], 10);
			ljPost.hour = parseInt(timearray[0], 10);
			ljPost.minute = parseInt(timearray[1], 10);
			ljPost.second = parseInt(timearray[2], 10);
			
			var secnode = document.getElementById("security");
			if (security) {
				switch (security.data) {
					case "private":
						secnode.selectedIndex = 1;
						dsPosts.changeSecurity(1, true);
						break;
					case "usemask":
						var allowmask = eventdict.getValue("allowmask").QueryInterface(Components.interfaces.nsISupportsPRInt32);
						if (allowmask == 1) {
							secnode.selectedIndex = 2;
							dsPosts.changeSecurity(1, true);
						} else {
							secnode.selectedIndex = 3;
							ljPost.allowmask = allowmask.data;
							dsPosts.changeSecurity(3, true);
						}
						break;
				}
			} else {
				secnode.selectedIndex = 0;
				dsPosts.changeSecurity(0, true);
			}
			if (subject) {
				document.getElementById("subject").value = subject.data;
			}
			document.getElementById("messagesource").value = event.data;
			dsMidas.syncNormalTab();
			// Otherwise you can't backspace until you enter some text. Hooray for workarounds!
			document.getElementById("message").contentDocument.designMode = "On";
			
			if (moodid) {
				for (i = 0; i < LiveJournal.moods.length; i++) {
					if (LiveJournal.moods[i].id == moodid.data) {
						document.getElementById("moods").selectedIndex = i;
						break;
					}
				}
			} else if (mood) {
				document.getElementById("moods").label = mood.data;
			}
			if (music) {
				document.getElementById("music").value = music.data;
			}
			if (dontautoformat) {
				ljPost.dontautoformat = true;
				dsMidas.dontautoformat = true;
			}
			if (removecomments) {
				ljPost.removecomments = true;
			}
			if (backdate) {
				ljPost.backdate = true;
			}
			if (pickw) {
				var picmenu = document.getElementById("picture");
				for (i = 0; i < LiveJournal.pickws.length; i++) {
					if (LiveJournal.pickws[i].pickw == pickw.data) {
						picmenu.selectedIndex = i + 1;
						dsPosts.changePicture(picmenu);
						break;
					}
				}
			}
			document.getElementById("maindisabler").removeAttribute("disabled");
			document.getElementById("postbutton").removeAttribute("disabled");
			document.getElementById("messagedeck").selectedIndex = 0;
	},
	onFault: function (client, ctxt, fault) {
			alert('XML-RPC Fault: '+fault);
	},
	onError: function (client, ctxt, status, errorMsg) {
			alert('Error: '+errorMsg);
	}
}

ljEdit.saveEdit = function() {
	if (this.posting) {
		this.posting = false;
		document.getElementById("maindisabler").removeAttribute("disabled");
		document.getElementById("messagedeck").selectedIndex = 0;
		document.getElementById("postbutton").label = "Save";
	} else {
		if (dsPrefs.getBoolPref("SpellCheckOnPost")) {
			// goDoCommand won't work for some reason.
			eval(document.getElementById("cmd_spell").getAttribute("oncommand"));
		}

		document.getElementById("postbutton").label = "Cancel";
		document.getElementById("maindisabler").setAttribute("disabled", true);
		document.getElementById("statuslabel").value = "Editing...";
		document.getElementById("statuswhat").value = "Saving your post on the server...";
		document.getElementById("progressbar").mode = "undetermined";
		document.getElementById("messagedeck").selectedIndex = 1;
		this.posting = true;
		ljEdit.editPostChallenge();
	}
}


ljEdit.editPostChallenge = function() {
	this.xmlrpc = Components.classes["@mozilla.org/xml-rpc/client2;1"].createInstance(Components.interfaces.nsIXmlRpcClient);
	this.xmlrpc.init(LiveJournal.posturl);
	document.getElementById("statuswhat").value = "Requesting challenge...";
	this.xmlrpc.asyncCall(this.editPostHandler, null, "LJ.XMLRPC.getchallenge", [], 0);
}

ljEdit.editPostHandler = {
	// In: Nothing.
	// Out: Nothing.
	onResult: function(client, ctxt, result) {
			var results = result.QueryInterface(Components.interfaces.nsIDictionary);
			var challenge = results.getValue("challenge").QueryInterface(Components.interfaces.nsISupportsCString);
			ljEdit.saveEditedPost(challenge);
	},
	onFault: function (client, ctxt, fault) {
		if (ljEdit.posting) {
			alert('XML-RPC Fault: '+fault);
			ljEdit.saveEdit();
		}
	},
	onError: function (client, ctxt, status, errorMsg) {
		if (ljEdit.posting) {
			alert('Error: '+errorMsg);
			ljEdit.saveEdit();
		}
	}
}

ljEdit.saveEditedPost = function(challengestring) {
	this.xmlrpc.init(LiveJournal.posturl);
	var dictionary = this.xmlrpc.createType(this.xmlrpc.STRUCT, {});
	paramstrings = new Object();
	paramints = new Object();
	paramstrings.username = LiveJournal.username;
	paramstrings.auth_method = "challenge";
	paramstrings.auth_challenge = challengestring;
	paramstrings.auth_response = hexMD5(challengestring + hexMD5(LiveJournal.password));
	paramints.ver = 1;
	paramstrings.lineendings = "unix";
	paramints.itemid = parseInt(postnum, 10);
	var subjectbox = document.getElementById("subject");
	if (subjectbox.value.trim().length > 0) {
		paramstrings.subject = subjectbox.value;
	}
	dsMidas.updateSourceTab();
	paramstrings.event = document.getElementById("messagesource").value;
	switch (this.security) {
		case 0:
			paramstrings.security = "public";
			break;
		case 1:
			paramstrings.security = "private";
			break;
		case 2:
			paramstrings.security = "usemask";
			paramints.allowmask = this.allowmask;
			break;
	}
	paramints.year = ljPost.year;
	paramints.mon = ljPost.month
	paramints.day = ljPost.day;
	paramints.hour = ljPost.hour;
	paramints.min = ljPost.minutes;
	
	if (LiveJournal.username != ljPost.usejournal) {
		paramstrings.usejournal = ljPost.usejournal;
	}

	// Ugh. Props will suck.
	var propsdictionary = this.xmlrpc.createType(this.xmlrpc.STRUCT, {});
	var propstrings = new Object();
	var propbools = new Object();
	var propints = new Object();
	var moodbox = document.getElementById("moods"); 
	if ((moodbox.selectedIndex < 0) && (moodbox.label.trim().length > 0)) {
		propstrings.current_mood = moodbox.label;
	} else if (moodbox.selectedIndex >= 0) {
		propints.current_moodid = LiveJournal.moods[moodbox.selectedIndex].id;
	}
	
	var musicbox = document.getElementById("music");
	if (musicbox.value.trim().length > 0) {
		propstrings.current_music = musicbox.value.trim();
	}
	
	if (ljPost.dontautoformat.toString() == "true") {
		propbools.opt_preformatted = true;
	}
	
	if (ljPost.removecomments.toString() == "true") {
		propbools.opt_nocomments = true;
	}
	
	if (ljPost.backdate.toString() == "true") {
		propbools.opt_backdated = true;
	}
	
	var pickwbox = document.getElementById("picture");
	if (pickwbox.selectedIndex > 0) {
		propstrings.picture_keyword = this.pickw;
	}
	
	// Start crunching up objects for RPC.
	this.makeRPCObjs(paramstrings, this.xmlrpc.STRING, dictionary);
	this.makeRPCObjs(paramints, this.xmlrpc.INT, dictionary);
	this.makeRPCObjs(propstrings, this.xmlrpc.STRING, propsdictionary);
	this.makeRPCObjs(propints, this.xmlrpc.INT, propsdictionary);
	this.makeRPCObjs(propbools, this.xmlrpc.BOOLEAN, propsdictionary);
	// Finish crunching up objects. 

	dictionary.setValue("props", propsdictionary);
	document.getElementById("statuswhat").value = "Editing post in journal: " + ljPost.usejournal;
	this.xmlrpc.asyncCall(this.editHandler, null, "LJ.XMLRPC.editevent", [dictionary], 1);
}

ljEdit.editHandler = {
	// In: Nothing.
	// Out: Nothing.
	onResult: function(client, ctxt, result) {
			// Workaround for weird bug where window won't close.
			setTimeout("window.close();", 1);
	},
	onFault: function (client, ctxt, fault) {
		if (ljEdit.posting) {
			alert('XML-RPC Fault: '+fault);
			ljEdit.saveEdit();
		}
	},
	onError: function (client, ctxt, status, errorMsg) {
		if (ljEdit.posting) {
			alert('Error: '+errorMsg);
			ljEdit.saveEdit();
		}
	}
}

ljEdit.makeRPCObjs = function(paramobj, makeobj, dict) {
	// Hmm. Identical to the makeRPCObjs function in livejournal.js. Note to self: Combine the two.
	// In: An object. Each item must be of an identical type (specified in the second parameter).
	//	They'll all be added to the dictionary specified in  the 'dict' parameter.
	// Out: Nothing, but your dict object will be populated.
	for (i in paramobj) {
		var rpcobj = this.xmlrpc.createType(makeobj, {});
		rpcobj.data = paramobj[i];
		dict.setValue(i, rpcobj);
	}
}
